package speiger.src.coreengine.platform.graphics.api.vertex.builder;

import speiger.src.coreengine.math.color.ColorUtils;

public interface IVertexBuilder {
	IVertexBuffer pos(float x, float y);
	IVertexBuffer pos(float x, float y, float z);
	
	default IVertexBuffer rgb(int color) { return rgb(ColorUtils.getR(color), ColorUtils.getG(color), ColorUtils.getB(color)); }
	IVertexBuffer rgb(int r, int g, int b);
	default IVertexBuffer rgba(int color) { return rgba(ColorUtils.getR(color), ColorUtils.getG(color), ColorUtils.getB(color), ColorUtils.getA(color)); }
	IVertexBuffer rgba(int r, int g, int b, int a);
	
	IVertexBuffer tex(float u, float v);
	IVertexBuffer normal(float x, float y, float z);
}
